####################
# version 2.0
####################


################################################################################
#                                                                              #
# NAME IO.temp 
# DESC temporary IO
#                                                                              #
################################################################################
"""
:NAME:
IO.temp

:DESC:
temporary IO

"""
# IMPORTS
#-------------------------------------------------------------------------------
import tempfile
import os
#-------------------------------------------------------------------------------
# IMPORTS

# CODE
#-------------------------------------------------------------------------------
class Temp:
    """
    Simple temp file class

    remove tempfile when deleting object if autodelete activated
    get filename by calling object

    ex: t = Tmp()
    print t()
    > 1212.tmp
    """

    def __init__(self, dir='', suffix='', autodelete=1):
        """
        dir        -- directory for temp
        autodelete -- boolean
        suffix     -- add suffix to tmp file
        """
        if dir:
            tempfile.tempdir = dir
        self.filename    = tempfile.mktemp(suffix=suffix)
        self.autodelete  = autodelete

    def write_string(self, s):
        f = open(self.filename, 'w')
        f.write(s)
        f.close()

    def __call__(self, absolutePath=True):
        if absolutePath:
            return self.filename
        else:
            return os.path.basename(self.filename)

    def remove(self):
        os.remove(self.filename)
        
    def __del__(self):
        if self.autodelete and os.path.exists(self.filename):
            self.remove()    


#-------------------------------------------------------------------------------
# CODE
