####################
# version 2.0
####################


################################################################################
#                                                                              #
# NAME IO.utils
# DESC IO utilities
#                                                                              #
################################################################################
"""
:NAME:
IO.utils

:DESC:
IO utilities

"""
# IMPORTS
#-------------------------------------------------------------------------------
import os
import time
import sys
import glob
import StringIO

#import Core.types as types

#-------------------------------------------------------------------------------
# IMPORTS

# CODE
#-------------------------------------------------------------------------------

def super_glob(filenames):
    r = []
    for filename in  filenames:
        if filename.find('*') != -1:
            r += glob.glob(filename)
        else:
            r += [ filename ]
    return r

   
def uopen(f, mode='r'):
    """Universal open hack
    f    -- file or filename
    mode -- string mode ('r', 'w' ...)
    Return file
    """
    try:
    	if type(f) is str:
    	    return open(f, mode)
    
    	if 'U' in mode and 'U' not in getattr(f, 'mode', ''):
    	    return StringIO.StringIO('\n'.join(f.read().splitlines()))        
    
   	    return f
    except IOError:
	    print "Error in opening file "+f+". "
	    sys.exit(1)
    except:
	    print "Error in opening the inputfile."
	

def f2Uf(f):
    return StringIO.StringIO('\n'.join(f.read().splitlines()))


def create_dir(path):
    try:
        if not os.path.exists(path):
            os.mkdirs(path)
            return True
    except IOError:
        print "Cannot create directory '%s'" % path
    return False  

def alternate_name(path, separator='-'):
    """Find an alternate name based on path
    """
    #cut path into (base, name, ext)
    base, tail = os.path.split(path)
    name, ext = os.path.splitext(tail)
    
    #guess file numbering (ex: name-08)
    try:
        n = int(name.split(separator)[-1])
    except:
        n = 0
    name = '%s%s%d' % (l, separator, n+1)
    return os.path.join(base, name + ext)

def clean_dir(dir, timeout=0):
    """
    dir       -- directory to clean
    timeout   -- in seconds (if current time - last access time > timeout remove file)
    """
    t = time.time()
    sys.stderr.write('cleaning DIR=%s\n' % dir)
    for f in os.listdir(dir):
        fi = os.path.join(dir,f)
        if t - os.stat(fi).st_atime > timeout:
            os.remove(fi)


def create_file(path, use_alternate_name=False):
    if not os.path.exists(path):
        return open(path, 'w')
    if os.path.exists(path) and use_alternate_name:
        root, ext, os.path.splitext(path)
        root



def files_exist(files):
    for f in files:
        if not os.path.isfile(f):
            return False
    return True


#-------------------------------------------------------------------------------
# CODE
