####################
# version 2.0
####################


################################################################################
#                                                                              #
# NAME Types.tab 
# DESC Tab utilities
#                                                                              #
################################################################################
"""
:NAME:
Types.tab

:DESC:
Array utilities

"""
# IMPORTS
#-------------------------------------------------------------------------------
from numpy import *
#-------------------------------------------------------------------------------
# IMPORTS

# CODE
#-------------------------------------------------------------------------------
def window(center, width, a, b):
    """
    @param center: int window center
    @param width: int window width
    
    @Return: [start,end] window of width width  in [a,b]
    """
    start = max(a, center - int(width / 2.0))
    start = min(start, b - width)
    return [start, start + width - 1]


def smooth(tab, windowWidth=500):
    """
    Smooth given table by averaging value in a sliding window of width windowSize
    @param windowSize: int

    """
    smoothTab = zeros(len(tab), 'float')
    for j in range(len(tab)):
        a, b = window(j, windowWidth, 0, len(tab))
        smoothTab[j] = add.reduce(tab[a:b+1]) / float(len(tab[a:b+1]))
    return smoothTab


def smooth_apply(t, f, windowWidth=10):
    """
    windowWidth should be even number
    """
    W2 = int(windowWidth/2.0)
    W  = windowWidth
    r = zeros(len(t), t.typecode())
    for i in range(W2, len(t)-W2, W):
        r[i-W2:i+W2+1] = f(t[i])#f( sum(t[i-W2:i+W2+1])/float(len(t[i-W2:i+W2+1])) )
    return r


def xyzip(y, xRange=None):
    """Return [(x0,y0), (x1,y1), ...]
    y    -- y table
    xRange -- optional x range tuple
    """
    xRange = xRange or (0, len(y)-1)
    return zip(range(xRange[0], xRange[1]+1), y)

#-------------------------------------------------------------------------------
# CODE
